# -*- coding: utf-8 -*-
from core.libs import *

HOST = "https://es.pornhub.com"


def mainlist(item):
    logger.trace()
    itemlist = list()

    itemlist.append(item.clone(
        action='videos',
        label='Útimos videos',
        url=HOST + '/video?o=cm',
        content_type='videos'
    ))

    itemlist.append(item.clone(
        action='listcategorias',
        label='Listado categorias',
        url=HOST + "/categories?o=al",
        content_type='items'
    ))

    itemlist.append(item.clone(
        action='search',
        label='Buscar',
        content_type='videos',
        category='adult',
        query=True
    ))

    return itemlist


def videos(item):
    logger.trace()
    itemlist = list()

    # Descarga la página
    data = httptools.downloadpage(item.url).data
    videodata = scrapertools.find_single_match(data, 'videos search-video-thumbs(.*?)<div class="reset"></div>')

    # Extrae las peliculas
    patron = '<div class="preloadLine">.*?'
    patron += '<a href="([^"]+)" title="([^"]+).*?'
    patron += 'data-mediumthumb="([^"]+)".*?'
    patron += '<var class="duration">([^<]+)</var>(.*?)</div>'

    matches = re.compile(patron, re.DOTALL).findall(videodata)
    for url, title, thumbnail, duration, scrapedhd in matches:
        title = title.replace("&amp;amp;", "&amp;") + " (" + duration + ")"

        scrapedhd = scrapertools.find_single_match(scrapedhd, '<span class="hd-thumbnail">(.*?)</span>')
        if scrapedhd == 'HD':
            title += ' [HD]'

        itemlist.append(item.clone(
            action='play',
            title=title,
            url=urllib_parse.urljoin(item.url, url),
            thumb=thumbnail,
            folder=False,
            type='video'
        ))

    if itemlist:
        # Paginador
        matches = re.compile('<li class="page_next"><a href="([^"]+)"', re.DOTALL).findall(data)
        if matches:
            itemlist.append(item.clone(
                action='videos',
                url=urllib_parse.urljoin(item.url, matches[0].replace('&amp;', '&')),
                type='next'
            ))

    return itemlist


def listcategorias(item):
    logger.trace()
    itemlist = list()

    # Descarga la página
    data = httptools.downloadpage(item.url).data
    data = re.sub(r"\n|\r|\t|\s{2}|&nbsp;", "", data)

    data = scrapertools.find_single_match(data, '<div id="categoriesStraightImages">(.*?)<div class="reset">')

    # Extrae las categorias
    patron = r'<li class="catPic" data-category=".*?<a href="([^"]+)".*?data-thumb_url="([^"]+)".*?alt="([^"]+)"'
    matches = re.compile(patron, re.DOTALL).findall(data)
    for url, thumbnail, label in matches:
        if "?" in url:
            url = urllib_parse.urljoin(item.url, url + "&o=cm")
        else:
            url = urllib_parse.urljoin(item.url, url + "?o=cm")

        itemlist.append(item.clone(
            action='videos',
            label=label,
            poster=thumbnail,
            url=url,
            content_type='videos',
            type='item'
        ))

    itemlist.sort(key=lambda x: x.label)
    return itemlist


def search(item):
    logger.trace()
    item.url = "https://es.pornhub.com/video/search?search=%s&o=mr" % item.query
    return videos(item)


def play(item):
    logger.trace()
    itemlist = list()

    # Descarga la página
    data = httptools.downloadpage(item.url)

    vid, js = scrapertools.find_single_match(data.data, r'var flashvars_([0-9a-z]+).*?(var [0-9a-z]+=.*?)\n')
    js = re.sub(r'/\*.*?\*/', '', js)

    code = [re.sub(r'var\s*', '', d) for d in js.split(';') if not d.startswith('flashvars_')]
    py_vars = {}
    exec('\n'.join(code), py_vars)
    logger.debug(vid)
    for video in py_vars['qualityItems_%s' % vid]:
        if video['url']:
            itemlist.append(Video(url=video['url'].replace('\\/', '/'), res=video['text'].lower()))

    return sorted(itemlist, key=lambda x: int(x.res[:-1]) if x.res else 0, reverse=True)
