# -*- coding: utf-8 -*-
from six.moves import urllib_request, urllib_response


class NoRedirectHandler(urllib_request.HTTPRedirectHandler):
    """
    Clase para no Seguir Redirecciones
    """
    def __init__(self):
        pass

    def http_error_302(self, req, fp, code, msg, headers):
        infourl = urllib_response.addinfourl(fp, headers, req.get_full_url())
        infourl.status = code
        infourl.code = code
        return infourl

    http_error_300 = http_error_302
    http_error_301 = http_error_302
    http_error_303 = http_error_302
    http_error_307 = http_error_302
